// pmQuickInset Plugin
// Initial code generated by Softimage SDK Wizard
// Executed Sun Aug 14 10:30:42 UTC+0200 2011 by leon
// 
// 
// Tip: You need to compile the generated code before you can load the plug-in.
// After you compile the plug-in, you can load it by clicking Update All in the Plugin Manager.
#include <xsi_application.h>
#include <xsi_context.h>
#include <xsi_pluginregistrar.h>
#include <xsi_status.h>
#ifndef linux
#define WIN32_LEAN_AND_MEAN
#include <windows.h> // Needed for OpenGL on windows
#endif
#include <GL/gl.h>
#include <xsi_math.h>
#include <xsi_argument.h>
#include <xsi_toolcontext.h>
#include <xsi_menu.h>
#include <xsi_menuitem.h>
#include <xsi_segment.h>
#include <xsi_siobject.h>
#include <xsi_point.h>
#include <xsi_edge.h>
#include <xsi_comapihandler.h>
#include <xsi_polygonface.h>
#include <xsi_vertex.h>
#include <xsi_kinematics.h>
#include <xsi_kinematicstate.h>
#include <xsi_statickinematicstate.h>
#include <xsi_preferences.h>
#include <xsi_operator.h>

using namespace XSI; 
using namespace XSI::MATH; 

const GLubyte halftonePolyMask[] = {
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55};

const int highlightColorR=20;
const int highlightColorG=220;
const int highlightColorB=20;
//const double stepsize = 0.1; //step size of extrusion when shift key is pressed

SICALLBACK XSILoadPlugin( PluginRegistrar& in_reg )
{
	in_reg.PutAuthor(L"piotrek marczak");
	in_reg.PutName(L"pmQuickInset Plugin");
	in_reg.PutVersion(0,1);
	in_reg.RegisterTool(L"pmQuickInset");
	in_reg.RegisterMenu(siMenuTbModelModifyPolygonMeshID,L"QuickInset_Menu",false,false);
	//RegistrationInsertionPoint - do not remove this line

	return CStatus::OK;
}

SICALLBACK XSIUnloadPlugin( const PluginRegistrar& in_reg )
{
	//CString strPluginName;
	//strPluginName = in_reg.GetName();
	//Application().LogMessage(strPluginName + L" has been unloaded.",siVerboseMsg);
	return CStatus::OK;
}

////////////////////////////////////////////////////////////////////////////////
//
// pmQuickInset
//
////////////////////////////////////////////////////////////////////////////////

class pmQuickInset {
private: // Data
	// Add tool data members here...
	LONG		m_cursorX;
	LONG 		m_cursorY;
	CVector3	m_CursorPos,m_CursorPos2;
	CRefArray	m_picked;
	X3DObject	objSelected;
	int			componentType;
	Point		edgePtA,edgePtB,vertSel;
	CVertexRefArray polyVertices;
	CString		componentString;
	PolygonFace	polyFace;
	int			highlightComp; //highlight 0-edges 1-faces 2-points
	Operator	op; //applied inset op
	bool		opApplied;
	bool		inset; //true - inset, false - extrude
	bool		meshOK;
	bool		spacebarJustPressed;
	CMatrix4	objMatrix;
	int			tagColorR,tagColorG,tagColorB;
public: // Methods
	pmQuickInset()
	{}

	~pmQuickInset()
	{}

	void GetToolHighlightColorFromPrefences(CString in_pref)
	{
		Application app;
		Preferences pref = app.GetPreferences();

		CValue tagColor;
		CStatus prefStatus = pref.GetPreferenceValue(in_pref, tagColor);
		if (prefStatus == CStatus::OK){
			this->tagColorR = ((int)tagColor>>24) & 255;
			this->tagColorG = ((int)tagColor>>16) & 255;
			this->tagColorB = ((int)tagColor>>8) & 255;
		}
		else app.LogMessage("No preferences found.");	
	}

	CStatus Setup( ToolContext& in_ctxt )
	{
		// Called when tool is created
		//GetToolHighlightColorFromPrefences("Scenecolors.compcol");
		this->tagColorR = highlightColorR;
		this->tagColorG = highlightColorG;
		this->tagColorB = highlightColorB;
		this->opApplied = false;
		this->inset = true;
		this->spacebarJustPressed = false;
		return CStatus::OK;
	}

	CStatus Cleanup( ToolContext& in_ctxt )
	{
		// Called when tool is destroyed
		return CStatus::OK;
	}

	CStatus Activate( ToolContext& in_ctxt )
	{
		/*bool meshesOK = true;
		Selection sel(Application().GetSelection);
		for (LONG i=0; i<sel.GetCount();; i++ )
        {
            SIObject obj(selection[i]);
            app.LogMessage( L"Selection " + CValue(i).GetAsText() +
                L"= " + obj.GetName() );
        }
		if (!meshesOK)
			in_ctxt.ExitTool();*/

		// Called when tool becomes the active tool
		in_ctxt.SetCursor( siCrossCursor );

		// Uncomment this to enable standard tool snapping behaviour
		//in_ctxt.EnableSnapping( true );

		//Uncomment this to setup a custom tool shortcut key
		in_ctxt.RegisterShortcutKey( 0x09/*Tab*/, L"Tab" );
		in_ctxt.RegisterShortcutKey( 0x20/*spacebar*/, L"Spacebar" );
		in_ctxt.RegisterShortcutKey( 0x0D/*enter*/, L"Enter" );
		// Set custom status message
		in_ctxt.SetToolDescription( L"pmQuickInset. Press TAB to switch between inset and extrue mode. Hold SPACEBAR to adjust inset during extrude.Hold SHIFT to increment extrusion in 0.1 steps. ENTER - inspect last op.\nExtrude amount\nRedo last\nExit tool" );

		return CStatus::OK;
	}

	CStatus Deactivate( ToolContext& in_ctxt )
	{
		// Called when tool becomes inactive (e.g. when user orbits using nav or chooses another tool)
		return CStatus::OK;
	}

	CStatus MouseDown( ToolContext& in_ctxt )
	{
		// Called when mouse button is pressed
		LONG x, y;
		in_ctxt.GetMousePosition( x, y );

		if ( ( in_ctxt.IsLeftButtonDown() || (in_ctxt.IsMiddleButtonDown() && !this->opApplied) ))
		{
			if ( componentString.IsEmpty()  || !this->meshOK )
				return CStatus::Fail;
			CValueArray args(5);
			CValue outArg;

			args[0] = CString(L"InsetPolygons");
			args[1] = componentString;
			Application().ExecuteCommand( L"ApplyOp", args, outArg );
			Operator opApp = ((const CValueArray&)outArg)[0];
			op = opApp;
			Parameter insetVal = (inset ? op.GetParameter(L"inset") : op.GetParameter(L"length"));

			//op.GetParameter(L"inset").PutValue(0.0);
			//op.GetParameter(L"length").PutValue(0.0);
			//op.GetParameter(L"skirtingratio").PutValue(0.01);

			
			in_ctxt.BeginParameterUpdate(op.GetParameter(L"length"));
			if (this->componentType != 1)
			{
				in_ctxt.BeginParameterUpdate(op.GetParameter(L"skirtingratio"));
				in_ctxt.UpdateParameter(op.GetParameter(L"skirtingratio"),0.01);
			}
			else
			{
				in_ctxt.BeginParameterUpdate(op.GetParameter(L"inset"));
				in_ctxt.UpdateParameter(op.GetParameter(L"inset"),0.0);
			}
			in_ctxt.UpdateParameter(op.GetParameter(L"length"),0.0);


			if ( in_ctxt.GetWorldPosition( x, y, this->m_CursorPos ) != CStatus::OK )
					return CStatus::OK;

			this->highlightComp = -1;
			in_ctxt.Redraw(true);
			this->opApplied = true;
			return CStatus::OK; // To start MouseDrag/MouseUp interaction...
		}
		else 
			if ( in_ctxt.IsRightButtonDown() )
			{
				// Show tool context menu
				in_ctxt.ExitTool();
				//in_ctxt.ShowContextMenu( x, y );
			}
			else 
				if ( (in_ctxt.IsMiddleButtonDown() && this->opApplied)&& this->meshOK)
				{
					if ( componentString.IsEmpty() || !op.IsConnected() )
						return CStatus::Fail;
					//redo last applyop command
					CValueArray args(5);
					CValue outArg;
					Operator oldOp = op;
					args[0] = CString(L"InsetPolygons");
					args[1] = componentString;
					Application().ExecuteCommand( L"ApplyOp", args, outArg );
					Operator opApp = ((const CValueArray&)outArg)[0];
					op = opApp;

					if (inset) 
					{
						op.GetParameter(L"inset").PutValue(oldOp.GetParameter(L"inset").GetValue() );
						op.GetParameter(L"length").PutValue(0.0);
						op.GetParameter(L"skirtingratio").PutValue(oldOp.GetParameter(L"skirtingratio").GetValue() );
					}
					else 
					{
						op.GetParameter(L"length").PutValue(oldOp.GetParameter(L"length").GetValue() );
						op.GetParameter(L"inset").PutValue( oldOp.GetParameter(L"inset").GetValue() );
						op.GetParameter(L"skirtingratio").PutValue( oldOp.GetParameter(L"skirtingratio").GetValue()) ;
					}
					//in_ctxt.UpdateParameter(op.GetParameter(L"skirtingratio" ),0.01);
					highlightComp = -1;
					this->MouseDrag(in_ctxt);
					return CStatus::False;
				}
		return CStatus::False; // Ignore other mouse buttons etc.
	}

	CStatus MouseDrag( ToolContext& in_ctxt )
	{
		// Called when mouse is moved with a mouse button pressed
		LONG x, y;
		in_ctxt.GetMousePosition( x, y );
		this->m_cursorX=x;
		this->m_cursorY=y;
		if ( in_ctxt.IsLeftButtonDown() )
		{
			if ( componentString.IsEmpty() || !op.IsConnected() || !this->meshOK) //is this neccessary? probably not...
				return CStatus::False;
			// Left button drag...
			if (inset) in_ctxt.SetCursor( siDragXYCursor );	else in_ctxt.SetCursor( siDragYCursor );

			CVector3 m_NewCursorPos;

			if ( in_ctxt.GetWorldPosition( x, y, m_NewCursorPos ) != CStatus::OK )
					return CStatus::OK;
			
			double offset_int = -(m_NewCursorPos.GetY()-this->m_CursorPos.GetY()); //calc distance mouse have travelled
			if (!inset) offset_int = -offset_int;

			Parameter insetVal;
			if (in_ctxt.IsShortcutKeyDown(0x20)) //spacebar pressed
			{
				if (this->spacebarJustPressed) //update only once when user hits spacebar
				{
					if ( in_ctxt.GetWorldPosition( x, y, m_CursorPos2) != CStatus::OK )
						return CStatus::OK;	
					spacebarJustPressed = false;
				}
				offset_int = -(m_NewCursorPos.GetY()-this->m_CursorPos2.GetY()); //calc distance mouse have travelled
				
				if(this->componentType != 1) //not poly
					insetVal = op.GetParameter(L"skirtingratio");
				else
					insetVal = op.GetParameter(L"inset");
			} 
			else
			{
				if(this->componentType != 1) //not poly
					insetVal = inset ? op.GetParameter(L"skirtingratio") : op.GetParameter(L"length");
				else						//edge, point
					insetVal = inset ? op.GetParameter(L"inset"): op.GetParameter(L"length");
			}
			//
			if ( in_ctxt.IsShiftKeyDown()) //shift key means extrusion step = 0.1
			{
				double frac, intp;
				frac = modf (offset_int, &intp);
				frac *= 10.0;
				frac = floor(frac);
				frac /= 10.0;
				//offset_int = floor(offset_int+stepsize);
				offset_int = intp + frac;
			}
			//Application().LogMessage(insetVal.GetName()+L"..."+CValue(insetVal).GetAsText()+"..."+CValue(offset_int).GetAsText() );
			if (insetVal.GetName() == L"Skirting Ratio") // skirting ratio should be between 0 and .999			
				offset_int = offset_int < 0 ? 0.01: ( offset_int > 0.999 ? 0.999 : offset_int );
			
			in_ctxt.UpdateParameter(insetVal,offset_int);
			//in_ctxt.Redraw( true );
		}
		return CStatus::OK;
	}

	CStatus MouseUp( ToolContext& in_ctxt )
	{
		// Called when mouse button is released
		//LONG x, y;
		//in_ctxt.GetMousePosition( x, y );

		if ( in_ctxt.IsLeftButtonDown() )
		{
			// Left button release...

			in_ctxt.EndParameterUpdate(this->op.GetParameter(L"length"));
			if (this->componentType != 1)		
				in_ctxt.EndParameterUpdate(this->op.GetParameter(L"skirtingratio"));
			else
				in_ctxt.EndParameterUpdate(this->op.GetParameter(L"inset"));

			//	Application().LogMessage( L"Mouse Up: <" + CString(x) + L", " + CString(y) + ">");
		}
		in_ctxt.SetCursor( siCrossCursor );
		return CStatus::OK;
	}

	CStatus Draw( ToolContext& in_ctxt )
	{
		// Called when a redraw occurs to allow the tool to show feedback
		if ( in_ctxt.IsActiveView() )
		{
			// This section will only be drawn for the active view (under the cursor)...
			if (highlightComp==0)
			{
					CVector3 posA(edgePtA.GetPosition());
					CVector3 posB(edgePtB.GetPosition());
					posA*=objMatrix;
					posB*=objMatrix;
					glColor4d( tagColorR/255.0, tagColorG/255.0, tagColorB/255.0,0.8 );
					glLineWidth(2.0f);
					glEnable(GL_BLEND);
					glEnable(GL_LINE_SMOOTH);
					glBegin( GL_LINES );
					glVertex3d( posA.GetX(),posA.GetY(),posA.GetZ() );
					glVertex3d( posB.GetX(),posB.GetY(),posB.GetZ() );
					glEnd();
					glDisable(GL_BLEND);
			}
			else 
				if (highlightComp==1)
				{
					glColor4d( tagColorR/255.0,tagColorG/255.0, tagColorB/255.0,0.7 );
					//glEnable( GL_DEPTH_TEST );
					glEnable( GL_BLEND );
					glEnable ( GL_POLYGON_STIPPLE );
					glPolygonStipple(halftonePolyMask);
					glBegin( GL_POLYGON );
					for (int i=0;i<polyVertices.GetCount();++i)
					{
						Vertex vert(polyVertices.GetItem(i));
						CVector3 v(vert.GetPosition());
						v*=objMatrix;
						glVertex3d( v.GetX(),v.GetY(),v.GetZ() );
					}					
					glEnd();
					glDisable ( GL_POLYGON_STIPPLE );
					//glDisable( GL_DEPTH_TEST );
					glDisable(GL_BLEND );

				}
				else
					if (highlightComp==2) //point
					{
							CVector3 pos(vertSel.GetPosition());
							pos*=objMatrix;
							glColor4d( tagColorR/255.0, tagColorG/255.0, tagColorB/255.0,0.9 );
							//glEnable(GL_BLEND);
							glPointSize(5.0f);
							glEnable(GL_POINT_SMOOTH);
							glBegin( GL_POINTS );
								glVertex3d( pos.GetX(),pos.GetY(),pos.GetZ() );
							glEnd();
							glDisable(GL_POINT_SMOOTH);
					}
			LONG viewWidth, viewHeight;
			
			// draw help text 
			if ( in_ctxt.GetViewSize( viewWidth, viewHeight ) == CStatus::OK )
			{
				in_ctxt.BeginViewDraw();
				glColor3f( 1.0,1.0, 1.0 );
				glRasterPos2i( viewWidth/2, 10 );
				if (inset)				
					in_ctxt.DrawTextString("Inset mode",siCenterAlign,siBottomAlign );
				else 
					in_ctxt.DrawTextString("Extrude mode",siCenterAlign,siBottomAlign );
				// draw info about extrusion length
				if (in_ctxt.IsInteracting())
				{
					CString l_Str;
					float val;
					if (in_ctxt.IsShortcutKeyDown(0x20))
					{
						if(this->componentType != 1)
							val = inset ? op.GetParameter(L"skirtingratio").GetValue() : op.GetParameter(L"length").GetValue();
						else
							val = op.GetParameter(L"inset").GetValue();
					}
					else
					{
						if(this->componentType != 1)
							val = inset ? op.GetParameter(L"skirtingratio").GetValue() : op.GetParameter(L"length").GetValue();
						else
							val = inset ? op.GetParameter(L"inset").GetValue(): op.GetParameter(L"length").GetValue();
					}
					l_Str = CValue( val ).GetAsText();
					LONG width = 0, height = 0, descent = 0;
					in_ctxt.GetTextSize( l_Str, width, height, descent );
					GLint x = (GLint)m_cursorX - width/2, y = (GLint)m_cursorY - 27/*pixels*/;
					glRasterPos2i(x ,y);
					in_ctxt.DrawTextString( l_Str );
				}
				in_ctxt.EndViewDraw();
			}
		}
		if ( in_ctxt.IsInteracting() )
		{
			// This section will only be drawn when dragging with a mouse button pressed...
		}
		return CStatus::OK;
	}

	CStatus MouseMove( ToolContext& in_ctxt )
	{
		Application app;		
		highlightComp = -1;
		// Called when mouse is moved without any buttons pressed
		m_picked.Clear();
		in_ctxt.GetMousePosition( m_cursorX, m_cursorY );
		CLongArray l_points;
		l_points.Add( m_cursorX );
		l_points.Add( m_cursorY );

		// First get object under the cursor
		CRefArray objects;
		in_ctxt.Pick( l_points, siPickSingleObject, siPickRaycast, siPolyMeshFilter, CRefArray(), objects );

		if ( objects.GetCount() > 0 )
		{
			if (objects[0].IsA( siX3DObjectID ) ) 
			{
				X3DObject xobj(objects[0]);
				if (xobj.GetType()=="polymsh")
				{
					meshOK = true;
					CTransformation objKine(xobj.GetKinematics().GetGlobal().GetTransform());
					objMatrix= objKine.GetMatrix4();
					objSelected = xobj;
					/* //select object
					CValueArray args(3);
					CValue outArg;
			
					args[0] = xobj.GetFullName();
					args[2] = "true";
					Application().LogMessage(args[0]);
					Application().ExecuteCommand( L"SelectObj", args, outArg );*/
				}
				else
				{
					meshOK = false;
					return CStatus::False;
				}

			}
			if (meshOK)
			{
				CRefArray components;
				this->componentType = 2;
				in_ctxt.Pick( l_points, siPickSingleSubComponent, siPickRaycast, siPointFilter, objects, components );			
				if( components.GetCount() == 0)
				{				
					in_ctxt.Pick( l_points, siPickSingleSubComponent, siPickRaycast, siEdgeFilter, objects, components );
					this->componentType = 0;
				}
				if( components.GetCount() == 0)
				{
					in_ctxt.Pick( l_points, siPickSingleSubComponent, siPickRaycast, siPolygonFilter, objects, components );
					this->componentType = 1;
				}
				if( components.GetCount()==0)
					this->componentType = -1;
				else 
				{
					componentString = components[0].GetAsText();
					CRef ref = components[0];
					if(ref.IsValid())
					{                              
						CComAPIHandler cCollItem(ref);
						CComAPIHandler cSubComp(cCollItem.GetProperty(L"SubComponent"));
						CComAPIHandler cCompColl(cSubComp.GetProperty(L"ComponentCollection"));
						if(LONG(cCompColl.GetProperty(L"Count")) == 1L)
						{
							CValue rVal;
							CValueArray rrParams;
							rrParams.Add(0L);
							CStatus bOk = cCompColl.Invoke(L"Item", CComAPIHandler::PropertyGet, rVal, rrParams);
							CRef compRef(rVal);
							if (componentType == 0)
							{
								Edge theEdge(compRef);
								CPointRefArray points(theEdge.GetPoints());
								this->edgePtA = points[0];
								this->edgePtB = points[1];
								this->highlightComp = 0;
								in_ctxt.Redraw( true );
							}
							else if (componentType == 1)
							{
								PolygonFace theFace(compRef);
								this->polyFace=theFace;
								this->polyVertices = theFace.GetVertices();
								this->highlightComp = 1;
								in_ctxt.Redraw( true );
							}
							else if (componentType == 2)
							{
								Point thePoint(compRef);
								this->vertSel = thePoint;
								this->highlightComp = 2;
								in_ctxt.Redraw( true );
							}
						}				
					}
				}
			}
		}
		return CStatus::OK;
	}

	CStatus KeyDown( ToolContext& in_ctxt )
	{
		// Called when a registered tool shortcut key is pressed
		switch (in_ctxt.GetShortcutKey()) {
		case 0x09:/*Tab*/ {
			// Tab key pressed...
			this->inset = !this->inset;
			if (inset) in_ctxt.SetCursor( siDragXYCursor );	
			else in_ctxt.SetCursor( siDragYCursor );
			//Application().LogMessage( L"Tab shortcut key pressed" );
			in_ctxt.Redraw(false);
			break;
		case 0x20:
			this->spacebarJustPressed = true;
			break;
		case 0x0D: //enter, inspect last op
			CValueArray args(1);
			CValue outArg;
			args[0] = this->op.GetFullName();
			Application().ExecuteCommand( L"InspectObj", args, outArg );
		}
		default:
			break;
		}
		return CStatus::OK;
	}

	CStatus KeyUp( ToolContext& in_ctxt )
	{
		// Called when a registered tool shortcut key is release
		return CStatus::OK;
	}

	CStatus SnapValid( ToolContext& in_ctxt )
	{
		// Return CStatus::OK if we can snap to this target...
		bool canSnapToTarget = true;
		//siSnapType snapType = in_ctxt.GetSnapType();
		//CRef snapObject = in_ctxt.GetSnapObject();
		return canSnapToTarget ? CStatus::OK : CStatus::False;
	}

	CStatus MenuInit( ToolContext& in_ctxt )
	{
		// Called to initialize the context menu
		/*
		MenuItem menuItem;
		Menu menu = in_ctxt.GetSource();
		menu.AddCallbackItem( L"Menu Item 1", L"pmQuickInset_DoMenuItem1", menuItem );
		menu.AddSeparatorItem();
		menu.AddCallbackItem( L"Exit Tool", L"pmQuickInset_DoExitTool", menuItem );
		*/
		return CStatus::OK;
	}

	CStatus DoMenuItem1( ToolContext& in_ctxt )
	{
		// Menu item selected...
		Application().LogMessage( L"Menu item 1 selected" );
		return CStatus::OK;
	}

	CStatus DoExitTool( ToolContext& in_ctxt )
	{
		in_ctxt.ExitTool();
		return CStatus::OK;
	}

}; // end class

////////////////////////////////////////////////////////////////////////////////
//
// Plugin Callbacks
//
////////////////////////////////////////////////////////////////////////////////

SICALLBACK QuickInset_Menu_Init( CRef& in_ctxt )
{
	Context ctxt( in_ctxt );
 	MenuItem menuItem;
 	Menu menu = ctxt.GetSource();
 	menu.AddCommandItem( L"Quick Inset", L"pmQuickInset", menuItem );
 	return true;
}

SICALLBACK pmQuickInset_Init( CRef& in_ctxt )
{
	pmQuickInset *l_pTool = new pmQuickInset;
	if ( !l_pTool ) return CStatus::Fail;
	ToolContext l_ctxt( in_ctxt );
	l_ctxt.PutUserData( CValue((CValue::siPtrType)l_pTool) );
	return CStatus::OK;
}

SICALLBACK pmQuickInset_Term( CRef& in_ctxt )
{
	ToolContext l_ctxt( in_ctxt );
	pmQuickInset *l_pTool = (pmQuickInset *)(CValue::siPtrType)l_ctxt.GetUserData();
	if ( !l_pTool ) return CStatus::Fail;
	delete l_pTool;
	l_ctxt.PutUserData( CValue((CValue::siPtrType)NULL) ); // Clear user data
	return CStatus::OK;
}

// Use a macro to simplify callback setup and forwarding...
#define DECLARE_TOOL_CALLBACK(TOOL,CALLBACK) \
SICALLBACK TOOL##_##CALLBACK( ToolContext& in_ctxt ) { \
	TOOL *l_pTool = (TOOL *)(CValue::siPtrType)in_ctxt.GetUserData(); \
	return ( l_pTool ? l_pTool->CALLBACK( in_ctxt ) : CStatus::Fail ); }

DECLARE_TOOL_CALLBACK( pmQuickInset, Setup );
DECLARE_TOOL_CALLBACK( pmQuickInset, Cleanup );
DECLARE_TOOL_CALLBACK( pmQuickInset, Activate );
DECLARE_TOOL_CALLBACK( pmQuickInset, Deactivate );
DECLARE_TOOL_CALLBACK( pmQuickInset, MouseDown );
DECLARE_TOOL_CALLBACK( pmQuickInset, MouseDrag );
DECLARE_TOOL_CALLBACK( pmQuickInset, MouseUp );
DECLARE_TOOL_CALLBACK( pmQuickInset, Draw );
DECLARE_TOOL_CALLBACK( pmQuickInset, MouseMove );
DECLARE_TOOL_CALLBACK( pmQuickInset, KeyDown );
DECLARE_TOOL_CALLBACK( pmQuickInset, KeyUp );
DECLARE_TOOL_CALLBACK( pmQuickInset, SnapValid );
DECLARE_TOOL_CALLBACK( pmQuickInset, MenuInit );
DECLARE_TOOL_CALLBACK( pmQuickInset, DoMenuItem1 );
DECLARE_TOOL_CALLBACK( pmQuickInset, DoExitTool );
